#include "VidHeader.h"

int main(int argc, char * argv[]) {

	if( argc != 2 ){
		fprintf( stderr, "Requires VID format filepath as the input argument.\n" );
		return 1;
	}

	VidHeader * vid = new VidHeader( argv[1], NULL );

	if( vid -> num_frames == 0 ){
		delete vid;
		return 1;
	}

	char outfile[1000];

	int frame_number = 0;

	while( frame_number < vid -> num_frames ) {

		vid -> readFrameFromVideoFile( frame_number );

		sprintf(outfile,"./frames/%05d.ppm", frame_number);

		vid -> writePPMimage(outfile, vid -> pixmap);

		if( frame_number % 20 == 1 ){
			fprintf( stdout, "Uncompressing frame %u to %s...\r", frame_number,	outfile );
			fflush( stdout );
		}

		frame_number++;
	}

	delete vid;
	return 0;
}

